Summary: Compiler tools for the CRIS CPU in Axis ETRAX chips.
# $Id: cris-dist.spec,v 1.2 2001/01/11 13:37:44 hp Exp $

%define name cris-dist
%define version 1.11
# It seems considered bad to have a "serial" version number, but
# we don't *need* to rely on it right now.  We put the N in RN
# for the gcc-cris version there in case we will ever need it
# by itself.
Serial: 32

Vendor: Axis Communications AB.
License: GNU General Public License
Name: %{name}
Version: %{version}
Release: 1

# These paths are what corrsponds to the defaults in
# install-cris-tools (with _prefix=/usr), so we want them to be
# the default, to minimize differences to installing from the
# .tar.gz distribution.  Note that this package is not
# relocateable.  It does have the prefix and individual
# directories compile-time configurable though, so all you need
# is the source RPM or the original tarballs and an extra hour
# or two.
%define installinfo_ %(which install-info)
%define libdir_ %{_prefix}/local/cris/lib
%define bindir_ %{_prefix}/local/cris
%define mandir_ %{_prefix}/local/man/man1
%define infodir_ %{_prefix}/local/info
%define pkg0 %{name}-%{version}
%define pkg1 %{name}-glibc-%{version}
%define pkg2 %{name}-elinux-headers-%{version}

Group: Development/Tools
Source: ftp://ftp.axis.se/pub/axis/tools/cris/compiler-kit/%{pkg0}.tar.gz

# If you find there is problems building glibc, and you don't
# need glibc installed, try killing the "glibc" and
# "elinux-headers" directories and the installation script should
# cope.
Source1: ftp://ftp.axis.se/pub/axis/tools/cris/compiler-kit/%{pkg1}.tar.gz
Source2: ftp://ftp.axis.se/pub/axis/tools/cris/compiler-kit/%{pkg2}.tar.gz

URL: http://developer.axis.com/
Packager: Compiler contact <compiler-contact@axis.com>

BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot
Requires: perl >= 5.004

%description
This toolsuite contains ports of GCC, binutils, newlib and glibc
for the CRIS CPU core in Axis Communications ETRAX chips.  It is
used to build all ETRAX-targeted software.  For details, see
%{_defaultdocdir}/%{pkg0}/README and %{_defaultdocdir}/%{pkg0}/NEWS
(file paths may vary).

%prep
rm -rf $RPM_BUILD_ROOT
%setup
%setup1 -T -D -a 1
%setup2 -T -D -a 2

%build
echo Building is not a separate step.

%install
./install-cris-tools %{libdir_} %{bindir_} %{mandir_} %{infodir_} $RPM_BUILD_DIR/%{pkg0}/tmpdir $RPM_BUILD_ROOT </dev/null
find $RPM_BUILD_ROOT ! -type d ! -name dir -print | sed -e "s@^$RPM_BUILD_ROOT@@g" > $RPM_BUILD_DIR/%{pkg0}/%{pkg0}-filelist

%clean
rm -rf $RPM_BUILD_ROOT

# Whoops! Can't use paths here.
%files -f %{pkg0}-filelist
%defattr(-,root,root)
%doc NEWS README
%docdir %{mandir_}
%docdir %{infodir_}

# Install info entries in the "directory" files.
%post
for f in %{infodir_}/*-cris.info
do
  %{installinfo_} $f %{infodir_}/dir
done

# Install info entries from the "directory" files.
%preun
if [ $1 = 0 ]; then
  for f in %{infodir_}/*-cris.info
  do
    %{installinfo_} --delete $f %{infodir_}/dir
  done
fi
